#ifndef _OBJECTADAPTER_H
#define _OBJECTADAPTER_H

#include <tao/corba.h>
#include <tao/PortableServer/PortableServerC.h>
#include "macro.h"

#ifndef OPENFUSION_COMMON_DLL
#define OPENFUSION_COMMON_DLL
#endif

class OPENFUSION_COMMON_DLL ObjectAdapter
{
  public:

    ObjectAdapter (CORBA::ORB_var orbVar, const CORBA::Boolean agent = 0);

    ObjectAdapter (CORBA::ORB_var orbVar, const char *poaName, const CORBA::Boolean agent = 0);

    ObjectAdapter (CORBA::ORB_var orbVar, ObjectAdapter *pAdapter, const char *poaName,
                   const CORBA::Boolean persistent = 0, const CORBA::Boolean agent = 0);

    virtual ~ObjectAdapter () {};

    void createTransient (PortableServer::ServantBase *pImpl);

    void createPersistent (PortableServer::ServantBase *pImpl);

    void create (CORBA::Boolean persistent = 0);

    void createTransient ();

    void createPersistent ();

    PortableServer::POA_var getPOA ();

    ObjectAdapter *getParent() const;

    char *getPoaName ();

    void addServantToAdapter (PortableServer::ServantBase *pImpl,
                              const char *name,
                              CORBA::Boolean persistent = 0);

    void activateManager ();

  protected:

  private:

    void initialiseRootPOA ();

    CORBA::ORB_var orbVar_;

    CORBA::Boolean agent_;

    ObjectAdapter *pParentOA_;

    char poaName_[255];

    PortableServer::POA_var rootPoaVar_;

    PortableServer::POA_var thisPoaVar_;

    PortableServer::POAManager_var poaManagerVar_;

    PortableServer::ObjectId_var managerIdVar_;
};
#endif  // _OBJECTADAPTER_H
