#ifndef _UTIL_H
#define _UTIL_H

#include "BankS.h"
#include "BankC.h"

#include "CosNamingC.h"
#include "CosNamingS.h"

#include <tao/corba.h>
#include <ace/OS.h>

#ifndef OPENFUSION_BANK_DLL
#define OPENFUSION_BANK_DLL
#endif

class OPENFUSION_BANK_DLL Util
{
  public:

    Util (CORBA::ORB_var orbVar);

    ~Util () {};

    PortableServer::POA_var getRootPOA ();

    void buildNameGraph ();

    Bank::AccountManager_ptr getAccManagerObject ();

    void bindAccountManager (CORBA::Object_ptr obj);

    void addAccount (const char *name, CORBA::Object_ptr obj);

    Bank::Account_ptr getAccount (const char* name);

  protected:

  private:

    CosNaming::NamingContextExt_var getRootNamingCtx ();

    CosNaming::NamingContext_var getAccManagerCtx ();

    CosNaming::NamingContext_var getAccountsCtx ();

    CosNaming::NamingContext_ptr myBindContext (CosNaming::NamingContext_ptr parentCtxVar, const char *ctxName);

    CORBA::ORB_var orbVar_;

    PortableServer::POA_var rootPoaVar_;

    CosNaming::NamingContextExt_var rootCtxVar_;

    CosNaming::NamingContext_var accMgrCtxVar_;

    CosNaming::NamingContext_var accountsCtxVar_;
};

#endif // _UTIL_H
