#include "Naming.h"


/*
 * @func Constructs a Naming object
 */
Naming::Naming()
{
}

/*
 * @func Destroy a Naming object
 */
Naming::~Naming()
{
}

/*
 * @func Resolves to an object with the given name in the given context
 */
CORBA::Boolean Naming::resolveToObject (CosNaming::Name *name, CosNaming::NamingContext_ptr ctx, CORBA::Object_ptr *obj)
{
  CORBA::Object_ptr object;

  ACE_TRY_NEW_ENV
    {
      object = ctx->resolve (*name ACE_ENV_ARG_PARAMETER);
      ACE_TRY_CHECK;
    }
  ACE_CATCHANY
    {
      ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION, ACE_TEXT ("ERROR: cannot resolve name\n"));
      return 0;
    }
  ACE_CATCHALL
    {
      ACE_DEBUG ((LM_ERROR, ACE_TEXT ("ERROR: cannot resolve name\n")));
      return 0;
    }
  ACE_ENDTRY;
  
  if (CORBA::is_nil (object))
    {
      ACE_DEBUG ((LM_ERROR, ACE_TEXT ("ERROR: NULL object reference\n")));
      return 0;
    }

   *obj = object;
   return 1;
}
