#include "VideoServiceProvider.h"


VideoServiceProvider::VideoServiceProvider (CORBA::ORB_var orbVar)
{
  pAdapter_ = new ObjectAdapter (orbVar);
  pAdapter_->createPersistent (this);
}

VideoServiceProvider::~VideoServiceProvider ()
{
  delete pAdapter_;
}

Server::CompanyNameList *
VideoServiceProvider::getCompanies ()
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  Server::CompanyNameList *companies = new Server::CompanyNameList;
  int count = 0;
  VideoCompany **company;

  ACE_DEBUG ((LM_INFO, ACE_TEXT ("Service Provider: managed companies:\n")));

  companies->length (companies_.size ());

  for (VideoCompanyArray::ITERATOR itb = VideoCompanyArray::ITERATOR (companies_); itb.next (company) != 0; itb.advance ())
    {
      (*companies)[count] = ACE_OS::strdup ((*company)->getName ());
      ACE_DEBUG ((LM_INFO, ACE_TEXT ("%s\n"), (*company)->getName()));
      count++;
    }

  return companies;
}

void
VideoServiceProvider::store (VideoCompany *company)
{
  companies_.size (companies_.size () + 1);
  companies_[companies_.size () - 1] = company;
}

CORBA::Object_var
VideoServiceProvider::getServant ()
{
  return pAdapter_->getPOA ()->servant_to_reference (this);
}

//IDL client connection test
void
VideoServiceProvider::helloWorld ()
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  ACE_DEBUG ((LM_INFO, ACE_TEXT ("Hello World\n")));
}

#if defined (ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION)
template class ACE_Array<VideoCompany*>;
template class ACE_Array_Base<VideoCompany*>;
template class ACE_Array_Iterator<VideoCompany*>;
#endif // ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION
