#ifndef _VIDEOSERVICEPROVIDER_H
#define _VIDEOSERVICEPROVIDER_H

#include "Common/ServerS.h"
#include "Common/ServerC.h"
#include "Common/ObjectAdapter.h"

#include "VideoCompany.h"

#include <ace/Containers_T.h>
#include <ace/OS.h>

#include "macro.h"


typedef ACE_Array<VideoCompany*> VideoCompanyArray;

class OPENFUSION_VIDEO_DLL VideoServiceProvider : public POA_Server::ServiceProvider
{
  public:

    VideoServiceProvider (CORBA::ORB_var orbVar);

    ~VideoServiceProvider ();

    Server::CompanyNameList *getCompanies ()
      ACE_THROW_SPEC ((CORBA::SystemException));

    void store (VideoCompany *company);

    ObjectAdapter *getObjectAdapter () {return pAdapter_;}

    CORBA::Object_var getServant ();

    void helloWorld ()
      ACE_THROW_SPEC ((CORBA::SystemException));

  protected:

  private:

    VideoCompanyArray companies_;

    ObjectAdapter *pAdapter_;
};

#endif  // _VIDEOSERVICEPROVIDER_H
