#ifndef _CHANNELUTIL_H
#define _CHANNELUTIL_H

#include "MailS.h"
#include <CosNotifyChannelAdminS.h>
#include <CosNotificationS.h>


class OPENFUSION_MAIL_DLL ChannelUtil
{
  public:

    ChannelUtil (CORBA::ORB_var orbVar);

    ~ChannelUtil ();

    CosNotifyChannelAdmin::EventChannel_var getChannel ();

    PortableServer::POA_var getRootPoa ();

    PortableServer::POA_var getDefaultTransientPoa ();

    PortableServer::POA_var getDefaultPersistentPoa ();

    PortableServer::POA_var createTransientPoa (const char *name);

    PortableServer::POA_var createPersistentPoa (const char *name);

    CORBA::Boolean fileExists (const char *filename);

    void deleteFile (const char *filename);

    void writeIOR (const char *filename, CORBA::Object_ptr obj);

    CORBA::Object_ptr readIOR (const char *filename);

  protected:

  private:

    PortableServer::POA_var createPoa (const char *name, CORBA::Boolean persistent);

    CORBA::ORB_var orbVar_;

    PortableServer::POA_var rootPoaVar_;

    PortableServer::POA_var transientPoaVar_;

    PortableServer::POA_var persistentPoaVar_;

    CosNotifyChannelAdmin::EventChannelFactory_var channelFactoryVar_;

    CosNotifyChannelAdmin::EventChannel_var channelVar_;
};
#endif  // _CHANNELUTIL_H
