#ifndef _MAILBOXIMPL_H
#define _MAILBOXIMPL_H

#include "MailS.h"
#include <CosNotifyChannelAdminS.h>
#include <CosNotificationS.h>

#include "ChannelUtil.h"

class MailBoxImpl : public POA_Mail::MailBox
{
  public:

    MailBoxImpl (CORBA::ORB_var orbVar, ChannelUtil *pUtil, const char *name);

    ~MailBoxImpl ();

    void sendMessage (const char *message, const Mail::StringSeq &to)
      ACE_THROW_SPEC ((CORBA::SystemException));

    CORBA::Boolean receiveMessage (CORBA::String_out sender, CORBA::String_out message)
      ACE_THROW_SPEC ((CORBA::SystemException));

    void destroy ()
      ACE_THROW_SPEC ((CORBA::SystemException));

    void offer_change (const CosNotification::EventTypeSeq & /*added*/, const CosNotification::EventTypeSeq & /*removed*/)
      ACE_THROW_SPEC ((CORBA::SystemException,CosNotifyComm::InvalidEventType));

    void subscription_change (const CosNotification::EventTypeSeq & /*added*/, const CosNotification::EventTypeSeq & /*removed*/)
      ACE_THROW_SPEC ((CORBA::SystemException,CosNotifyComm::InvalidEventType));

    void disconnect_structured_pull_consumer ()
      ACE_THROW_SPEC ((CORBA::SystemException));

    void disconnect_structured_push_supplier ()
      ACE_THROW_SPEC ((CORBA::SystemException));

  protected:

  private:

    CORBA::ORB_var orbVar_;

    ChannelUtil *pUtil_;

    char *username_;

    PortableServer::POA_var poaVar_;

    PortableServer::ObjectId_var oidVar_;

    CosNotifyChannelAdmin::StructuredProxyPullSupplier_var inboxProxyVar_;

    CosNotifyChannelAdmin::StructuredProxyPushConsumer_var outboxProxyVar_;
};
#endif  // _MAILBOXIMPL_H
