/*
 * Receives structured events containing stock quote information.
 */

#include "Analyst.h"


Analyst::~Analyst ()
{
}

void
Analyst::select (const char *bureau)
{
  // Create the constraint expression.
  char constraint[60];
  ACE_OS::strcpy (constraint, ACE_TEXT ("$bureau == \'"));
  ACE_OS::strcat (constraint, bureau);
  ACE_OS::strcat (constraint, ACE_TEXT ("\' and $Priority >= 5"));
  ACE_DEBUG ((LM_INFO, ACE_TEXT ("Constraint: %s\n"), constraint));

  setFilter (ACE_TEXT ("News"), ACE_TEXT ("StockQuote"), constraint);
}

int
main (int argc, char **argv)
{
  // Initialise the ORB instance.
  CORBA::ORB_var orbVar = CORBA::ORB_init (argc, argv, "");

  // Create the analyst.
  Analyst analyst (orbVar);

  // Connect to the event channel and set up the appropriate filter.
  analyst.connectToChannel ();
  analyst.select (ACE_TEXT ("Wall Street"));

  // Wait to receive events.
  ACE_DEBUG ((LM_INFO, ACE_TEXT ("Waiting to receive events\n")));
  orbVar->run ();

  return 0;
}
