/*
 * Receives structured events containing weather reports.
 */

#include "WeatherMan.h"


WeatherMan::~WeatherMan ()
{
}

void
WeatherMan::select (const char *bureau)
{
  // Create the constraint expression.
  char constraint[40];
  ACE_OS::strcpy (constraint, "$bureau == \'");
  ACE_OS::strcat (constraint, bureau);
  ACE_OS::strcat (constraint, "\'");
  ACE_DEBUG ((LM_INFO, "Constraint: %s\n", constraint));

  setFilter ("News", "Weather", constraint);
}

int
main (int argc, char **argv)
{
  // Initialise the ORB instance.
  CORBA::ORB_var orbVar = CORBA::ORB_init (argc, argv, "");

  // Create the weather man.
  WeatherMan weatherMan (orbVar);

  // Connect to the event channel and set up the appropriate filter.
  weatherMan.connectToChannel ();
  weatherMan.select (ACE_TEXT ("Station North"));

  // Wait to receive events.
  ACE_DEBUG ((LM_INFO, ACE_TEXT ("Waiting to receive events\n")));
  orbVar->run ();

  return 0;
}
