#ifndef _ANYPUSHCONSUMERIMPL_H
#define _ANYPUSHCONSUMERIMPL_H

#include <CosNotifyCommS.h>
#include <CosNotifyChannelAdminS.h>
#include <CosNotificationS.h>

#include "ChannelUtil.h"


class AnyPushConsumerImpl : public POA_CosNotifyComm::PushConsumer
{
  public:

    AnyPushConsumerImpl (CORBA::ORB_var orbVar, ChannelUtil *pUtil);

    ~AnyPushConsumerImpl ();

    void disconnect_push_consumer ()
      ACE_THROW_SPEC ((CORBA::SystemException));

    void offer_change (const CosNotification::EventTypeSeq & /*added*/, const CosNotification::EventTypeSeq & /*removed*/)
      ACE_THROW_SPEC ((CosNotifyComm::InvalidEventType,CORBA::SystemException));

    void push (const CORBA::Any &event)
      ACE_THROW_SPEC ((CosEventComm::Disconnected,CORBA::SystemException));

  protected:

  private:

    void connectToChannel ();

    CORBA::ORB_var orbVar_;

    ChannelUtil *pUtil_;

    CosNotifyComm::PushConsumer_var consumerVar_;
};

#endif  // _ANYPUSHCONSUMERIMPL_H
