#ifndef _ANYPUSHSUPPLIERIMPL_H
#define _ANYPUSHSUPPLIERIMPL_H

#include <CosNotifyCommS.h>
#include <CosNotifyChannelAdminS.h>
#include <CosNotificationS.h>

#include "ChannelUtil.h"


class AnyPushSupplierImpl : public POA_CosNotifyComm::PushSupplier
{
  public:

    AnyPushSupplierImpl (CORBA::ORB_var orbVar, ChannelUtil *pUtil);

    ~AnyPushSupplierImpl ();

    void disconnect_push_supplier ()
      ACE_THROW_SPEC ((CORBA::SystemException));

    void subscription_change (const CosNotification::EventTypeSeq & /*added*/, const CosNotification::EventTypeSeq & /*removed*/)
      ACE_THROW_SPEC ((CosNotifyComm::InvalidEventType,CORBA::SystemException));

    void pushEvents ();

  protected:

  private:

    void connectToChannel ();

    CORBA::ORB_var orbVar_;

    ChannelUtil *pUtil_;

    CosNotifyComm::PushSupplier_var supplierVar_;

    CosNotifyChannelAdmin::ProxyPushConsumer_var proxyVar_;
};

#endif // _ANYPUSHSUPPLIERIMPL_H
