#ifndef _SEQUENCEPUSHCONSUMERIMPL_H
#define _SEQUENCEPUSHCONSUMERIMPL_H

#include <CosNotifyCommS.h>
#include <CosNotifyChannelAdminS.h>
#include <CosNotificationS.h>

#include "tao/TimeBaseC.h"

#include "ChannelUtil.h"


class SequencePushConsumerImpl : public POA_CosNotifyComm::SequencePushConsumer
{
  public:

    SequencePushConsumerImpl (CORBA::ORB_var orbVar, ChannelUtil *pUtil);

    ~SequencePushConsumerImpl ();

    void disconnect_sequence_push_consumer ()
      ACE_THROW_SPEC ((CORBA::SystemException));

    void offer_change (const CosNotification::EventTypeSeq & /*added*/, const CosNotification::EventTypeSeq & /*removed*/)
      ACE_THROW_SPEC ((CosNotifyComm::InvalidEventType,CORBA::SystemException));

    void push_structured_events (const CosNotification::EventBatch &events)
      ACE_THROW_SPEC ((CosEventComm::Disconnected,CORBA::SystemException));

  protected:

  private:

    void connectToChannel ();

    CORBA::ORB_var orbVar_;

    ChannelUtil *pUtil_;

    CosNotifyComm::SequencePushConsumer_var consumerVar_;
};

#endif  // _SEQUENCEPUSHCONSUMERIMPL_H
