#ifndef _STRUCTUREDPUSHCONSUMERIMPL_H
#define _STRUCTUREDPUSHCONSUMERIMPL_H

#include <CosNotifyCommS.h>
#include <CosNotifyChannelAdminS.h>
#include <CosNotificationS.h>

#include "ChannelUtil.h"


class StructuredPushConsumerImpl : public POA_CosNotifyComm::StructuredPushConsumer
{
  public:

    StructuredPushConsumerImpl (CORBA::ORB_var orbVar, ChannelUtil *pUtil);

    ~StructuredPushConsumerImpl ();

    void disconnect_structured_push_consumer ()
      ACE_THROW_SPEC ((CORBA::SystemException));

    void offer_change (const CosNotification::EventTypeSeq & /*added*/, const CosNotification::EventTypeSeq & /*removed*/)
      ACE_THROW_SPEC ((CosNotifyComm::InvalidEventType,CORBA::SystemException));

    void push_structured_event (const CosNotification::StructuredEvent &event)
      ACE_THROW_SPEC ((CosEventComm::Disconnected,CORBA::SystemException));

  protected:

  private:

    void connectToChannel ();

    CORBA::ORB_var orbVar_;

    ChannelUtil *pUtil_;

    CosNotifyComm::StructuredPushConsumer_var consumerVar_;
};

#endif  // _STRUCTUREDPUSHCONSUMERIMPL_H
