#include "Mortgage.h"


MortgageImpl::MortgageImpl (const char *name, CORBA::Float rate)
  : name_ (0), rate_ (0)
{
  name_ = ACE_OS::strdup (name);
  rate_ = rate/100;
}

MortgageImpl::~MortgageImpl ()
{
}

char *
MortgageImpl::name ()
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  return ACE_OS::strdup (name_);
}

CORBA::Float
MortgageImpl::rate ()
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  return rate_;
}

void
MortgageImpl::calculateMortgage (CORBA::Long loan_amount, CORBA::Short years)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  CORBA::Double annual_payments = 0.0;
  CORBA::Double monthly_payments = 0.0;

  annual_payments = ((loan_amount*pow ((1+rate_),years)*rate_))/((pow ((1+rate_),years)-1));
  monthly_payments = annual_payments/12;

  ACE_DEBUG ((LM_INFO, ACE_TEXT ("Your annual payments for a $%i mortgage over %i years with %s will be: $%.2f\n"),
              loan_amount, years, name (), annual_payments));

  ACE_DEBUG ((LM_INFO, ACE_TEXT ("Your monthly payments for a $%i mortgage over %i years with %s will be: $%.2f\n"),
              loan_amount, years, name (), monthly_payments));
}
