#include "Util.h"


Util::Util (CORBA::ORB_var orbVar)
  : orbVar_ (orbVar), rootPoaVar_ (0)
{
}

PortableServer::POA_var
Util::getRootPOA (void)
{
  CORBA::Object_var objVar;

  if (rootPoaVar_ == 0)
    {
      ACE_TRY_NEW_ENV
        {
          objVar = orbVar_->resolve_initial_references (ACE_TEXT ("RootPOA") ACE_ENV_ARG_PARAMETER);
          rootPoaVar_ = PortableServer::POA::_narrow (objVar.in () ACE_ENV_ARG_PARAMETER);
        }
      ACE_CATCHANY
        {
          ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION, ACE_TEXT ("ERROR: Failed to obtain a reference to the root POA\n"));
          exit (-1);
        }
      ACE_ENDTRY;
    }
    
  return rootPoaVar_;
}
