#ifndef _VIDEOSERVICEPROVIDER_H
#define _VIDEOSERVICEPROVIDER_H

#include "Common/ServerS.h"
#include "Common/ServerC.h"
#include "Common/ObjectAdapter.h"

#include "VideoCompany.h"

#include <ace/Containers_T.h>
#include <ace/OS.h>

#include "macro.h"

typedef ACE_Array<VideoCompany*> VideoCompanyArray;

#ifndef OPENFUSION_VIDEO_DLL
#define OPENFUSION_VIDEO_DLL
#endif

class OPENFUSION_VIDEO_DLL VideoServiceProvider : public POA_Server::ServiceProvider
{
  public:

    VideoServiceProvider (CORBA::ORB_var orbVar);

    ~VideoServiceProvider ();

    Server::CompanyNameList *getCompanies ()
      ACE_THROW_SPEC ((CORBA::SystemException));

    void store (VideoCompany *company, const char *name);

    ObjectAdapter *getObjectAdapter ()
    {
      return pAdapter_;
    }

    ObjectAdapter *getVideoObjectAdapter ()
    {
      return pAdapterVideos_;
    }

    CORBA::Object_var getServant ();

    void activateManager ();

    void helloWorld ()
      ACE_THROW_SPEC ((CORBA::SystemException));

   protected:

      VideoCompanyArray companies_;

   private:

      CORBA::ORB_var orbVar_;

      ObjectAdapter *pAdapter_;

      ObjectAdapter *pAdapterVideos_;
};

#endif  // _VIDEOSERVICEPROVIDER_H
