// $Id: SSLExample_i.h,v 1.4 2007-03-21 10:30:15 ir Exp $

#ifndef SSL_EXAMPLE_H
#define SSL_EXAMPLE_H

#include "ace/Get_Opt.h"
#include "ace/OS_NS_stdio.h"
#include "ace/OS_NS_unistd.h"
#include "ace/Read_Buffer.h"
#include "ace/Task.h"

#include <tao/corba.h>
#include <tao/PortableServer/PortableServer.h>
#include "tao/ORB_Core.h"
#include <ace/OS.h>

#include "orbsvcs/SSLIOPC.h"

#include "SSLExampleS.h"


class ORBThread : public ACE_Task_Base
{
  public:

    ORBThread (CORBA::ORB_ptr orb);

    virtual int svc (void);

  private:

    CORBA::ORB_var orbVar_;
};


class SSLExample_i : public POA_SSLExample, public ACE_Event_Handler
{
  public:

    SSLExample_i (int, char**);
    
    ~SSLExample_i ();

    void send_message (const char *)
      throw (CORBA::SystemException);

    void start_test ()
      throw ();

    void handle_user_input ();

    // Boolean indicating if this is to run in automated test mode.
    bool test_;

  private:

    int parse_args (int, char**);

    void initialise (int, char**);

    char *readIOR (const char*);
    
    int writeIOR (const char*, const char*);

    int handle_input (ACE_HANDLE);

    void parse_line (char *line)
      throw ();

    // General CORBA references.
    CORBA::ORB_var orbVar_;
    PortableServer::POA_var rootPoaVar_;
    PortableServer::POAManager_var poaManagerVar_;
    SSLIOP::Current_var currentVar_;

    // ORB thread.
    ORBThread *orb_thread_;

    // IOR file names for the three components.
    const char *server_ior_file_;
    const char *client_ior_file_;
    const char *service_ior_file_;

    // CORBA references for the three components.
    SSLExample_var clientVar_;
    SSLExample_var serverVar_;
    SSLExample_var serviceVar_;

    // Booleans to indicate which component this instance represents.
    bool is_server_;
    bool is_client_;
    bool is_service_;

    // Strings indicating which component to send data to.
    const char *SERVER_STRING;
    const char *CLIENT_STRING;
    const char *SERVICE_STRING;
    
    // String with the "exit" command.
    const char *EXIT_STRING;

    // References for the component's role.
    const char **ior_file_ptr_;
    char *role_name_;
};


#endif /* SSL_EXAMPLE_H */
