// -*- C++ -*-
//
// $Id$

// ****  Code generated by the The ACE ORB (TAO) IDL Compiler ****
// TAO and the TAO IDL Compiler have been developed by:
//       Center for Distributed Object Computing
//       Washington University
//       St. Louis, MO
//       USA
//       http://www.cs.wustl.edu/~schmidt/doc-center.html
// and
//       Distributed Object Computing Laboratory
//       University of California at Irvine
//       Irvine, CA
//       USA
//       http://doc.ece.uci.edu/
// and
//       Institute for Software Integrated Systems
//       Vanderbilt University
//       Nashville, TN
//       USA
//       http://www.isis.vanderbilt.edu/
//
// Information about TAO is available at:
//     http://www.cs.wustl.edu/~schmidt/TAO.html

// TAO_IDL - Generated from
// be/be_codegen.cpp:520

#ifndef _TAO_IDL____INCLUDE_REFLECTIVES_T_H_
#define _TAO_IDL____INCLUDE_REFLECTIVES_T_H_

#include /**/ "ace/pre.h"

// TAO_IDL - Generated from 
// be/be_visitor_root/root_sth.cpp:116

namespace POA_Reflective
{
  
  // TAO_IDL - Generated from
  // be/be_visitor_interface/tie_sh.cpp:87
  
  // TIE class: Refer to CORBA v2.2, Section 20.34.4
  template <class T>
  class  RefBaseObject_tie : public RefBaseObject
  {
  public:
    RefBaseObject_tie (T &t);
    // the T& ctor
    RefBaseObject_tie (T &t, PortableServer::POA_ptr poa);
    // ctor taking a POA
    RefBaseObject_tie (T *tp, ::CORBA::Boolean release = 1);
    // ctor taking pointer and an ownership flag
    RefBaseObject_tie (
        T *tp,
        PortableServer::POA_ptr poa,
        ::CORBA::Boolean release = 1
      );
    // ctor with T*, ownership flag and a POA
    ~RefBaseObject_tie (void);
    // dtor
    
    // TIE specific functions
    T *_tied_object (void);
    // return the underlying object
    void _tied_object (T &obj);
    // set the underlying object
    void _tied_object (T *obj, ::CORBA::Boolean release = 1);
    // set the underlying object and the ownership flag
    ::CORBA::Boolean _is_owner (void);
    // do we own it
    void _is_owner ( ::CORBA::Boolean b);
    // set the ownership
    
    // overridden ServantBase operations
    PortableServer::POA_ptr _default_POA (
        ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS
      );
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::Reflective::DesignatorType_ptr meta_object (
        ACE_ENV_SINGLE_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::CORBA::Boolean itself (
        ::Reflective::RefBaseObject_ptr
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::Reflective::RefBaseObject_ptr repository_container (
        ACE_ENV_SINGLE_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException
      ));
  
  private:
    T *ptr_;
    PortableServer::POA_var poa_;
    ::CORBA::Boolean rel_;
    
    // copy and assignment are not allowed
    RefBaseObject_tie (const RefBaseObject_tie &);
    void operator= (const RefBaseObject_tie &);
  };
  
  // TAO_IDL - Generated from
  // be/be_visitor_interface/tie_sh.cpp:87
  
  // TIE class: Refer to CORBA v2.2, Section 20.34.4
  template <class T>
  class  RefObject_tie : public RefObject
  {
  public:
    RefObject_tie (T &t);
    // the T& ctor
    RefObject_tie (T &t, PortableServer::POA_ptr poa);
    // ctor taking a POA
    RefObject_tie (T *tp, ::CORBA::Boolean release = 1);
    // ctor taking pointer and an ownership flag
    RefObject_tie (
        T *tp,
        PortableServer::POA_ptr poa,
        ::CORBA::Boolean release = 1
      );
    // ctor with T*, ownership flag and a POA
    ~RefObject_tie (void);
    // dtor
    
    // TIE specific functions
    T *_tied_object (void);
    // return the underlying object
    void _tied_object (T &obj);
    // set the underlying object
    void _tied_object (T *obj, ::CORBA::Boolean release = 1);
    // set the underlying object and the ownership flag
    ::CORBA::Boolean _is_owner (void);
    // do we own it
    void _is_owner ( ::CORBA::Boolean b);
    // set the ownership
    
    // overridden ServantBase operations
    PortableServer::POA_ptr _default_POA (
        ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS
      );
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::Reflective::DesignatorType_ptr meta_object (
        ACE_ENV_SINGLE_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::CORBA::Boolean itself (
        ::Reflective::RefBaseObject_ptr
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::Reflective::RefBaseObject_ptr repository_container (
        ACE_ENV_SINGLE_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::CORBA::Boolean is_instance_of (
        ::Reflective::DesignatorType_ptr,
        ::CORBA::Boolean
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::Reflective::RefObject_ptr create_instance (
        const ::Reflective::ValueTypeList &
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::TooManyParameters,
        ::Reflective::MissingParameter,
        ::Reflective::InvalidValue,
        ::Reflective::AlreadyCreated,
        ::Reflective::StructuralError,
        ::Reflective::ConstraintError,
        ::Reflective::SemanticError
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::Reflective::RefObjectSet * all_objects (
        ::CORBA::Boolean
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    void set_value (
        ::Reflective::DesignatorType_ptr,
        const ::Reflective::ValueType &
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidDesignator,
        ::Reflective::InvalidValue,
        ::Reflective::StructuralError,
        ::Reflective::ConstraintError,
        ::Reflective::SemanticError
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::Reflective::ValueType * value (
        ::Reflective::DesignatorType_ptr
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidDesignator,
        ::Reflective::SemanticError
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    void add_value (
        ::Reflective::DesignatorType_ptr,
        const ::Reflective::ValueType &
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidDesignator,
        ::Reflective::InvalidValue,
        ::Reflective::StructuralError,
        ::Reflective::ConstraintError,
        ::Reflective::SemanticError
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    void add_value_before (
        ::Reflective::DesignatorType_ptr,
        const ::Reflective::ValueType &,
        const ::Reflective::ValueType &
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidDesignator,
        ::Reflective::InvalidValue,
        ::Reflective::NotFound,
        ::Reflective::StructuralError,
        ::Reflective::ConstraintError,
        ::Reflective::SemanticError
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    void add_value_at (
        ::Reflective::DesignatorType_ptr,
        const ::Reflective::ValueType &,
        ::CORBA::Long
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidDesignator,
        ::Reflective::InvalidValue,
        ::Reflective::BadPosition,
        ::Reflective::StructuralError,
        ::Reflective::ConstraintError,
        ::Reflective::SemanticError
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    void modify_value (
        ::Reflective::DesignatorType_ptr,
        const ::Reflective::ValueType &,
        const ::Reflective::ValueType &
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidDesignator,
        ::Reflective::InvalidValue,
        ::Reflective::NotFound,
        ::Reflective::StructuralError,
        ::Reflective::ConstraintError,
        ::Reflective::SemanticError
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    void modify_value_at (
        ::Reflective::DesignatorType_ptr,
        const ::Reflective::ValueType &,
        ::CORBA::Long
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidDesignator,
        ::Reflective::InvalidValue,
        ::Reflective::BadPosition,
        ::Reflective::StructuralError,
        ::Reflective::ConstraintError,
        ::Reflective::SemanticError
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    void remove_value (
        ::Reflective::DesignatorType_ptr,
        const ::Reflective::ValueType &
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidDesignator,
        ::Reflective::InvalidValue,
        ::Reflective::NotFound,
        ::Reflective::StructuralError,
        ::Reflective::ConstraintError,
        ::Reflective::SemanticError
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    void remove_value_at (
        ::Reflective::DesignatorType_ptr,
        ::CORBA::Long
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidDesignator,
        ::Reflective::InvalidValue,
        ::Reflective::BadPosition,
        ::Reflective::NotFound,
        ::Reflective::StructuralError,
        ::Reflective::ConstraintError,
        ::Reflective::SemanticError
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::Reflective::ValueType * invoke_operation (
        ::Reflective::DesignatorType_ptr,
        const ::Reflective::ValueTypeList &
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidDesignator,
        ::Reflective::TooManyParameters,
        ::Reflective::MissingParameter,
        ::Reflective::InvalidValue,
        ::Reflective::OtherException,
        ::Reflective::ConstraintError,
        ::Reflective::SemanticError
      ));
  
  private:
    T *ptr_;
    PortableServer::POA_var poa_;
    ::CORBA::Boolean rel_;
    
    // copy and assignment are not allowed
    RefObject_tie (const RefObject_tie &);
    void operator= (const RefObject_tie &);
  };
  
  // TAO_IDL - Generated from
  // be/be_visitor_interface/tie_sh.cpp:87
  
  // TIE class: Refer to CORBA v2.2, Section 20.34.4
  template <class T>
  class  RefAssociation_tie : public RefAssociation
  {
  public:
    RefAssociation_tie (T &t);
    // the T& ctor
    RefAssociation_tie (T &t, PortableServer::POA_ptr poa);
    // ctor taking a POA
    RefAssociation_tie (T *tp, ::CORBA::Boolean release = 1);
    // ctor taking pointer and an ownership flag
    RefAssociation_tie (
        T *tp,
        PortableServer::POA_ptr poa,
        ::CORBA::Boolean release = 1
      );
    // ctor with T*, ownership flag and a POA
    ~RefAssociation_tie (void);
    // dtor
    
    // TIE specific functions
    T *_tied_object (void);
    // return the underlying object
    void _tied_object (T &obj);
    // set the underlying object
    void _tied_object (T *obj, ::CORBA::Boolean release = 1);
    // set the underlying object and the ownership flag
    ::CORBA::Boolean _is_owner (void);
    // do we own it
    void _is_owner ( ::CORBA::Boolean b);
    // set the ownership
    
    // overridden ServantBase operations
    PortableServer::POA_ptr _default_POA (
        ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS
      );
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::Reflective::DesignatorType_ptr meta_object (
        ACE_ENV_SINGLE_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::CORBA::Boolean itself (
        ::Reflective::RefBaseObject_ptr
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::Reflective::RefBaseObject_ptr repository_container (
        ACE_ENV_SINGLE_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::CORBA::Boolean link_exists (
        const ::Reflective::Link &
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidLink,
        ::Reflective::SemanticError
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::Reflective::RefObjectUList * query (
        ::Reflective::DesignatorType_ptr,
        ::Reflective::RefObject_ptr
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidDesignator,
        ::Reflective::InvalidObject,
        ::Reflective::SemanticError
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    void add_link (
        const ::Reflective::Link &
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidLink,
        ::Reflective::StructuralError,
        ::Reflective::ConstraintError,
        ::Reflective::SemanticError
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    void add_link_before (
        const ::Reflective::Link &,
        ::Reflective::DesignatorType_ptr,
        ::Reflective::RefObject_ptr
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidDesignator,
        ::Reflective::InvalidObject,
        ::Reflective::InvalidLink,
        ::Reflective::NotFound,
        ::Reflective::StructuralError,
        ::Reflective::ConstraintError,
        ::Reflective::SemanticError
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    void modify_link (
        const ::Reflective::Link &,
        ::Reflective::DesignatorType_ptr,
        ::Reflective::RefObject_ptr
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidDesignator,
        ::Reflective::InvalidObject,
        ::Reflective::InvalidLink,
        ::Reflective::NotFound,
        ::Reflective::StructuralError,
        ::Reflective::ConstraintError,
        ::Reflective::SemanticError
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    void remove_link (
        const ::Reflective::Link &
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidLink,
        ::Reflective::NotFound,
        ::Reflective::StructuralError,
        ::Reflective::ConstraintError,
        ::Reflective::SemanticError
      ));
  
  private:
    T *ptr_;
    PortableServer::POA_var poa_;
    ::CORBA::Boolean rel_;
    
    // copy and assignment are not allowed
    RefAssociation_tie (const RefAssociation_tie &);
    void operator= (const RefAssociation_tie &);
  };
  
  // TAO_IDL - Generated from
  // be/be_visitor_interface/tie_sh.cpp:87
  
  // TIE class: Refer to CORBA v2.2, Section 20.34.4
  template <class T>
  class  RefPackage_tie : public RefPackage
  {
  public:
    RefPackage_tie (T &t);
    // the T& ctor
    RefPackage_tie (T &t, PortableServer::POA_ptr poa);
    // ctor taking a POA
    RefPackage_tie (T *tp, ::CORBA::Boolean release = 1);
    // ctor taking pointer and an ownership flag
    RefPackage_tie (
        T *tp,
        PortableServer::POA_ptr poa,
        ::CORBA::Boolean release = 1
      );
    // ctor with T*, ownership flag and a POA
    ~RefPackage_tie (void);
    // dtor
    
    // TIE specific functions
    T *_tied_object (void);
    // return the underlying object
    void _tied_object (T &obj);
    // set the underlying object
    void _tied_object (T *obj, ::CORBA::Boolean release = 1);
    // set the underlying object and the ownership flag
    ::CORBA::Boolean _is_owner (void);
    // do we own it
    void _is_owner ( ::CORBA::Boolean b);
    // set the ownership
    
    // overridden ServantBase operations
    PortableServer::POA_ptr _default_POA (
        ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS
      );
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::Reflective::DesignatorType_ptr meta_object (
        ACE_ENV_SINGLE_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::CORBA::Boolean itself (
        ::Reflective::RefBaseObject_ptr
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::Reflective::RefBaseObject_ptr repository_container (
        ACE_ENV_SINGLE_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::Reflective::RefObject_ptr get_class_ref (
        ::Reflective::DesignatorType_ptr
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidDesignator
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::Reflective::RefAssociation_ptr get_association (
        ::Reflective::DesignatorType_ptr
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidDesignator
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::Reflective::RefPackage_ptr get_nested_package (
        ::Reflective::DesignatorType_ptr
        ACE_ENV_ARG_DECL
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::Reflective::InvalidDesignator
      ));
  
  private:
    T *ptr_;
    PortableServer::POA_var poa_;
    ::CORBA::Boolean rel_;
    
    // copy and assignment are not allowed
    RefPackage_tie (const RefPackage_tie &);
    void operator= (const RefPackage_tie &);
  };
} // module Reflective

// TAO_IDL - Generated from 
// be/be_codegen.cpp:1251
#if defined (__ACE_INLINE__)
#include "ReflectiveS_T.inl"
#endif /* defined INLINE */

#if defined (ACE_TEMPLATES_REQUIRE_SOURCE)
#include "ReflectiveS_T.cpp"
#endif /* defined REQUIRED SOURCE */

#if defined (ACE_TEMPLATES_REQUIRE_PRAGMA)
#pragma implementation ("ReflectiveS_T.cpp")
#endif /* defined REQUIRED PRAGMA */

#include /**/ "ace/post.h"
#endif /* ifndef */

