// $Id: CSD_ORBInitializer.cpp,v 1.1.1.1.8.1 2008-02-01 13:30:18 vz Exp $
#include "tao/CSD_Framework/CSD_ORBInitializer.h"

#if defined (TAO_HAS_CORBA_MESSAGING) && TAO_HAS_CORBA_MESSAGING != 0

ACE_RCSID (CSD_Framework,
           CSD_ORBInitializer,
           "$Id: CSD_ORBInitializer.cpp,v 1.1.1.1.8.1 2008-02-01 13:30:18 vz Exp $")

#include "tao/CSD_Framework/CSD_Object_Adapter_Factory.h"
#include "tao/ORB_Core.h"
#include "tao/PI/ORBInitInfo.h"

#include "ace/OS_NS_string.h"

TAO_BEGIN_VERSIONED_NAMESPACE_DECL

void
TAO_CSD_ORBInitializer::pre_init (
    PortableInterceptor::ORBInitInfo_ptr info
    ACE_ENV_ARG_DECL)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  // Narrow to a TAO_ORBInitInfo object to get access to the
  // orb_core() TAO extension.
  TAO_ORBInitInfo_var tao_info = TAO_ORBInitInfo::_narrow (info);

  if (CORBA::is_nil (tao_info.in ()))
    {
      if (TAO_debug_level > 0)
        ACE_ERROR ((LM_ERROR,
                    "(%P|%t) TAO_CSD_ORBInitializer::pre_init:\n"
                    "(%P|%t)    Unable to narrow "
                    "\"PortableInterceptor::ORBInitInfo_ptr\" to\n"
                    "(%P|%t)   \"TAO_ORBInitInfo *.\"\n"));

      throw ::CORBA::INTERNAL ();
    }

  bool register_factory = true;

  CORBA::StringSeq_var args = tao_info->arguments ();
  for (CORBA::ULong i = 0; i < args->length (); ++i)
    {
      if (ACE_OS::strcmp (args[i], ACE_TEXT("-CSDDisable")) == 0)
        {
          register_factory = false;
          break;
        }
    }

  if (register_factory)
    {
      // If the application resolves the root POA, make sure we load the CSD POA.
      tao_info->orb_core ()->orb_params ()->poa_factory_name ("TAO_CSD_Object_Adapter_Factory");

      tao_info->orb_core ()->orb_params ()->poa_factory_directive ("dynamic TAO_CSD_Object_Adapter_Factory Service_Object * TAO_CSD_Framework:_make_TAO_CSD_Object_Adapter_Factory()");
    }
}

void
TAO_CSD_ORBInitializer::post_init (
    PortableInterceptor::ORBInitInfo_ptr
    ACE_ENV_ARG_DECL)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
}

TAO_END_VERSIONED_NAMESPACE_DECL

#endif /* TAO_HAS_CORBA_MESSAGING && TAO_HAS_CORBA_MESSAGING != 0 */
