// $Id: ServerImpl.cpp,v 1.2 2006-11-29 14:02:09 sm Exp $

#include "tao/orbconf.h"
///
/// ImplRepo related.
///
#if (TAO_HAS_MINIMUM_CORBA == 0)

#include "ServerImpl.h"

ServerImpl::ServerImpl()
: heartbeat_(0),
  id_(0),  
  orb_ (0)
{
}

ServerImpl::ServerImpl( CORBA::ORB_ptr orb )
: heartbeat_(0),
  id_(0),
  orb_ (CORBA::ORB::_duplicate (orb))
{
}

ServerImpl::~ServerImpl()
{
}

imr::ServerID 
ServerImpl::id ( ACE_ENV_SINGLE_ARG_DECL )
                 ACE_THROW_SPEC (( CORBA::SystemException ))
{
  return id_;
}

void 
ServerImpl::id ( imr::ServerID id
                ACE_ENV_ARG_DECL )
                ACE_THROW_SPEC (( CORBA::SystemException ))
{
  id_ = id;
}

imr::Interval 
ServerImpl::heartbeat ( ACE_ENV_SINGLE_ARG_DECL )
           ACE_THROW_SPEC (( CORBA::SystemException ))
{
  return heartbeat_;
}

void
ServerImpl::heartbeat ( imr::Interval heartbeat 
                       ACE_ENV_ARG_DECL ) 
                       ACE_THROW_SPEC (( CORBA::SystemException ))
{
  heartbeat_ = heartbeat;
  // @todo Setting a non-zero heartbeat should prompt this server
  // to periodically ping the ImR
}

void
ServerImpl::ping ( imr::ServerID from 
                  ACE_ENV_ARG_DECL )
                  ACE_THROW_SPEC (( CORBA::SystemException ))
{
  ACE_UNUSED_ARG (from);
  // no-op
}

void
ServerImpl::shutdown ( CORBA::Boolean wait
                      ACE_ENV_ARG_DECL )
                      ACE_THROW_SPEC (( CORBA::SystemException ))
{
  if (wait)
    ACE_THROW (CORBA::BAD_PARAM ());
  
  this->orb_->shutdown (0 ACE_ENV_ARG_PARAMETER);
  ACE_CHECK;
}

#endif /* TAO_HAS_MINIMUM_CORBA == 0 */

