// -*- C++ -*-
//=============================================================================
/**
 *  @file   ServerImpl.h
 *
 *  $Id: ServerImpl.h,v 1.1 2006-05-13 11:29:55 sm Exp $
 */
//=============================================================================

#ifndef IMRSERVERIMPL_H
#define IMRSERVERIMPL_H

#include "POA_IMRS.h"

#include "imr_client_export.h"

/**
 * @class ServerImpl
 *
 * @brief The servant that should run in all IMR administered servers.
 *
 * Provides mainly shutdown and ping functionality as a base class for running servers / Daemons.
 * Should live on the root POA, one per ORB.
 *
 * @author Simon McQueen <sm@prismtechnologies.com>
 *
 */
class TAO_IMR_Client_Export ServerImpl : public virtual POA_imr::Server
{
public:
  // = Constructors and destructor
  ServerImpl (void );
  ServerImpl (CORBA::ORB_ptr orb);
  ~ServerImpl (void);

  virtual imr::ServerID id ( ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS )
                             ACE_THROW_SPEC (( CORBA::SystemException ));

  virtual void id ( imr::ServerID id ACE_ENV_ARG_DECL_WITH_DEFAULTS )
                    ACE_THROW_SPEC (( CORBA::SystemException ));

  virtual imr::Interval heartbeat ( ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS )
                           ACE_THROW_SPEC (( CORBA::SystemException ));

  virtual void heartbeat ( imr::Interval heartbeat ACE_ENV_ARG_DECL_WITH_DEFAULTS )
                           ACE_THROW_SPEC (( CORBA::SystemException ));

  virtual void ping ( imr::ServerID from ACE_ENV_ARG_DECL_WITH_DEFAULTS )
                      ACE_THROW_SPEC (( CORBA::SystemException ));

  virtual void shutdown ( CORBA::Boolean wait ACE_ENV_ARG_DECL_WITH_DEFAULTS )
                          ACE_THROW_SPEC (( CORBA::SystemException ));
protected:

  imr::Interval heartbeat_;

  imr::ServerID id_;

  CORBA::ORB_ptr orb_;
};

#endif /* IMRSERVERIMPL_H */

