// $Id: POAFiltering.cpp,v 1.1 2007-06-06 11:07:59 vz Exp $

#include "tao/POAFiltering/POAFiltering_ORBInitializer.h"
#include "tao/POAFiltering/POAFiltering.h"
#include "tao/POAFiltering/POA_Acceptor_Filter.h"
#include "tao/ORB_Core.h"
#include "tao/debug.h"
#include "tao/ORBInitializer_Registry.h"

ACE_RCSID (POAFiltering,
           POAFiltering,
           "$Id: POAFiltering.cpp,v 1.1 2007-06-06 11:07:59 vz Exp $")

TAO_BEGIN_VERSIONED_NAMESPACE_DECL

// Set the flag to zero to start with
int TAO_POAFiltering_Loader::is_activated_ = 0;

TAO_POAFiltering_Loader::TAO_POAFiltering_Loader (void)
{
}

TAO_POAFiltering_Loader::~TAO_POAFiltering_Loader (void)
{
}

int
TAO_POAFiltering_Loader::init (int,
                               ACE_TCHAR* [])
{
  if (TAO_POAFiltering_Loader::is_activated_ == 0)
    {
      PortableInterceptor::ORBInitializer_ptr tmp_orb_initializer =
        PortableInterceptor::ORBInitializer::_nil ();
      PortableInterceptor::ORBInitializer_var orb_initializer;

      try
        {
          /// Register the POAFiltering ORBInitializer.
          ACE_NEW_THROW_EX (tmp_orb_initializer,
                            TAO_POAFiltering_ORBInitializer,
                            CORBA::NO_MEMORY (
                                CORBA::SystemException::_tao_minor_code (
                                    TAO::VMCID,
                                    ENOMEM),
                                CORBA::COMPLETED_NO));

          orb_initializer = tmp_orb_initializer;

          PortableInterceptor::register_orb_initializer (
            orb_initializer.in ());

          TAO_POAFiltering_Loader::is_activated_ = 1;
        }
      catch (const ::CORBA::Exception& ex)
        {
          if (TAO_debug_level > 0)
            {
              ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION,
                                   "Caught exception:");
            }
          return -1;
        }
    }

  return 0;
}

TAO_Acceptor_Filter *
TAO_POAFiltering_Loader::create_acceptor_filter (TAO_ORB_Core &oc,
                                                 TAO_Root_POA &poa)
{
  TAO_Acceptor_Filter *filter = 0;
  ACE_NEW_THROW_EX (filter,
                    TAO_POA_Acceptor_Filter (oc, poa),
                    CORBA::NO_MEMORY ());

  return filter;
}

int
TAO_POAFiltering_Loader::Initializer (void)
{
  return ACE_Service_Config::process_directive (ace_svc_desc_TAO_POAFiltering_Loader);
}

TAO_END_VERSIONED_NAMESPACE_DECL

ACE_STATIC_SVC_DEFINE (TAO_POAFiltering_Loader,
                       ACE_TEXT ("POAFiltering_Loader"),
                       ACE_SVC_OBJ_T,
                       &ACE_SVC_NAME (TAO_POAFiltering_Loader),
                       ACE_Service_Type::DELETE_THIS | ACE_Service_Type::DELETE_OBJ,
                       0)
ACE_FACTORY_DEFINE (TAO_POAFiltering, TAO_POAFiltering_Loader)
