// $Id: POAFiltering_ORBInitializer.cpp,v 1.1 2007-06-06 11:07:59 vz Exp $

#include "tao/POAFiltering/POAFiltering_ORBInitializer.h"
#include "tao/POAFiltering/POAFiltering_PolicyFactory.h"
#include "tao/POAFiltering/POAFiltering.h"

#include "tao/ORB_Constants.h"

ACE_RCSID (POAFiltering,
           POAFiltering_ORBInitializer,
           "$Id: POAFiltering_ORBInitializer.cpp,v 1.1 2007-06-06 11:07:59 vz Exp $")

TAO_BEGIN_VERSIONED_NAMESPACE_DECL

void
TAO_POAFiltering_ORBInitializer::pre_init (
    PortableInterceptor::ORBInitInfo_ptr)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  //
}

void
TAO_POAFiltering_ORBInitializer::post_init (
    PortableInterceptor::ORBInitInfo_ptr info)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  this->register_policy_factories (info);
}

void
TAO_POAFiltering_ORBInitializer::register_policy_factories (
  PortableInterceptor::ORBInitInfo_ptr info)
{
  /// Register the POAFiltering policy factories.
  PortableInterceptor::PolicyFactory_ptr temp_factory =
    PortableInterceptor::PolicyFactory::_nil ();

  /// This policy factory is used for all POAFiltering related policies.
  ACE_NEW_THROW_EX (temp_factory,
                    TAO_POAFiltering_PolicyFactory,
                    CORBA::NO_MEMORY (
                      CORBA::SystemException::_tao_minor_code (
                         TAO::VMCID,
                         ENOMEM),
                      CORBA::COMPLETED_NO));

  PortableInterceptor::PolicyFactory_var policy_factory = temp_factory;

  /// Bind the same policy factory to all POAFiltering related policy
  /// types since a single policy factory is used to create each of
  /// the different types of POAFiltering policies.

  CORBA::PolicyType type;

  type = POAFilterPolicy::POA_FILTER_POLICY_TYPE;
  info->register_policy_factory (type,
                                 policy_factory.in ());
}

TAO_END_VERSIONED_NAMESPACE_DECL
