// $Id: POAFiltering_PolicyFactory.cpp,v 1.1 2007-06-06 11:07:59 vz Exp $

#include "tao/POAFiltering/POAFiltering_PolicyFactory.h"
#include "tao/POAFiltering/POAFiltering.h"
#include "tao/POAFiltering/POAFiltering_Policy_i.h"

#include "tao/ORB_Constants.h"
#include "tao/AnyTypeCode/Any.h"

ACE_RCSID (POAFiltering,
           POAFiltering_PolicyFactory,
           "$Id: POAFiltering_PolicyFactory.cpp,v 1.1 2007-06-06 11:07:59 vz Exp $")

TAO_BEGIN_VERSIONED_NAMESPACE_DECL

CORBA::Policy_ptr
TAO_POAFiltering_PolicyFactory::create_policy (
    CORBA::PolicyType type,
    const CORBA::Any &value)
  ACE_THROW_SPEC ((CORBA::SystemException,
                   CORBA::PolicyError))
{
  CORBA::Policy_ptr policy = CORBA::Policy::_nil ();

  if (type == POAFilterPolicy::POA_FILTER_POLICY_TYPE)
    {
      POAFilterPolicy::TAO_POAFilterPolicyValue val;

      // Extract the value from the any.
      value >>= val;
      if ((value >>= val) == 0)
        {
          ACE_THROW_RETURN (CORBA::PolicyError (CORBA::BAD_POLICY_VALUE),
                            CORBA::Policy::_nil ());
        }

      ACE_NEW_THROW_EX (policy,
                        TAO_POAFilteringPolicy (val),
                        CORBA::NO_MEMORY (
                          CORBA::SystemException::_tao_minor_code (
                            TAO::VMCID,
                            ENOMEM),
                          CORBA::COMPLETED_NO));

      return policy;
    }

  ACE_THROW_RETURN (CORBA::PolicyError (CORBA::BAD_POLICY_TYPE),
                    CORBA::Policy::_nil ());
}

TAO_END_VERSIONED_NAMESPACE_DECL
