// -*- C++ -*-

//=============================================================================
/**
 *  @file    POAFilterCreator_Adapter.h
 *
 *  $Id: POAFilterCreator_Adapter.h,v 1.1 2007-06-06 11:07:59 vz Exp $
 *
 *  @author  Vladimir Zykov <Vladimir.Zykov@prismtech.com>
 */
//=============================================================================

#ifndef TAO_POAFILTERCREATOR_ADAPTER_H
#define TAO_POAFILTERCREATOR_ADAPTER_H

#include /**/ "ace/pre.h"

#include "tao/PortableServer/portableserver_export.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

#include "tao/Acceptor_Filter.h"
#include "ace/Service_Object.h"

TAO_BEGIN_VERSIONED_NAMESPACE_DECL

class TAO_ORB_Core;
class TAO_Root_POA;

/**
 * @class TAO_POAFilterCreator_Adapter
 *
 * @brief TAO_POAFilterCreator_Adapter.
 *
 * Class that offers an interface to the PortableServer to create
 * acceptor filter.
 */
class TAO_PortableServer_Export TAO_POAFilterCreator_Adapter
  : public ACE_Service_Object
{
public:

  /// The virtual destructor
  virtual ~TAO_POAFilterCreator_Adapter (void);

  virtual TAO_Acceptor_Filter *create_acceptor_filter (TAO_ORB_Core &oc,
                                                       TAO_Root_POA &poa) = 0;

};

TAO_END_VERSIONED_NAMESPACE_DECL

#include /**/ "ace/post.h"

#endif /* TAO_POAFILTERCREATOR_ADAPTER_H */
