// $Id: POAFiltering_Policy_i.cpp,v 1.1 2007-06-06 11:07:59 vz Exp $

#include "tao/POAFiltering/POAFiltering_Policy_i.h"

#include "tao/Stub.h"
#include "tao/debug.h"
#include "tao/ORB_Constants.h"

ACE_RCSID (TAO,
           POAFiltering_Policy_i,
           "$Id: POAFiltering_Policy_i.cpp,v 1.1 2007-06-06 11:07:59 vz Exp $")

TAO_BEGIN_VERSIONED_NAMESPACE_DECL

TAO_POAFilteringPolicy::TAO_POAFilteringPolicy (
    const POAFilterPolicy::TAO_POAFilterPolicyValue val)
  : ACE_NESTED_CLASS (CORBA, Object) ()
  , ACE_NESTED_CLASS (CORBA, Policy) ()
  , ACE_NESTED_CLASS (POAFilterPolicy, TAO_POAFilterPolicy) ()
  , ACE_NESTED_CLASS (CORBA, LocalObject) ()
  , TAO_Local_RefCounted_Object ()
  , value_ (val)
{
}

TAO_POAFilteringPolicy::TAO_POAFilteringPolicy (const TAO_POAFilteringPolicy &rhs)
  : ACE_NESTED_CLASS (CORBA, Object) ()
  , ACE_NESTED_CLASS (CORBA, Policy) ()
  , ACE_NESTED_CLASS (POAFilterPolicy, TAO_POAFilterPolicy) ()
  , ACE_NESTED_CLASS (CORBA, LocalObject) ()
  , TAO_Local_RefCounted_Object ()
  , value_ (rhs.value_)
{
}

CORBA::PolicyType
TAO_POAFilteringPolicy::policy_type ()
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  // Future policy implementors: notice how this minimizes the
  // footprint of the class.
  return POAFilterPolicy::POA_FILTER_POLICY_TYPE;
}

CORBA::Policy_ptr
TAO_POAFilteringPolicy::copy ()
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  // Future policy implementors: notice how the following code is
  // exception safe!

  TAO_POAFilteringPolicy* tmp;
  ACE_NEW_THROW_EX (tmp, TAO_POAFilteringPolicy (*this),
                    CORBA::NO_MEMORY (TAO::VMCID,
                                      CORBA::COMPLETED_NO));

  return tmp;
}

void
TAO_POAFilteringPolicy::destroy ()
  ACE_THROW_SPEC ((CORBA::SystemException))
{
}

POAFilterPolicy::TAO_POAFilterPolicyValue
TAO_POAFilteringPolicy::value ()
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  return this->value_;
}

TAO_END_VERSIONED_NAMESPACE_DECL
