// -*- C++ -*-

// ===================================================================
/**
 *  @file POAFiltering_Policy_i.h
 *
 *  $Id: POAFiltering_Policy_i.h,v 1.1 2007-06-06 11:07:59 vz Exp $
 *
 *  @author Vladimir Zykov <Vladimir.Zykov@prismtech.com>
 */
// ===================================================================

#ifndef TAO_POAFILTERING_POLICY_I_H
#define TAO_POAFILTERING_POLICY_I_H
#include /**/ "ace/pre.h"

#include "tao/POAFiltering/poafiltering_export.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

#include "tao/POAFiltering/POAFiltering.h"
#include "tao/LocalObject.h"

#if defined(_MSC_VER)
# pragma warning(push)
# pragma warning(disable:4250)
#endif /* _MSC_VER */

TAO_BEGIN_VERSIONED_NAMESPACE_DECL

/**
 * @class TAO_POAFilteringPolicy
 *
 * @brief  Implementation of the POAFilterPolicy::TAO_POAFilterPolicy
 */
class TAO_POAFilteringPolicy
  : public virtual POAFilterPolicy::TAO_POAFilterPolicy
  , public virtual TAO_Local_RefCounted_Object
{
public:

  /// Constructor.
  TAO_POAFilteringPolicy (const POAFilterPolicy::TAO_POAFilterPolicyValue val);

  /// Copy constructor.
  TAO_POAFilteringPolicy (const TAO_POAFilteringPolicy &rhs);

  /// = The POAFilter::TAO_POAFilteringPolicy methods
  virtual POAFilterPolicy::TAO_POAFilterPolicyValue value ()
    ACE_THROW_SPEC ((CORBA::SystemException));

  virtual CORBA::PolicyType policy_type ()
    ACE_THROW_SPEC ((CORBA::SystemException));

  virtual CORBA::Policy_ptr copy ()
    ACE_THROW_SPEC ((CORBA::SystemException));

  virtual void destroy ()
    ACE_THROW_SPEC ((CORBA::SystemException));

private:

  /// The attribute
  POAFilterPolicy::TAO_POAFilterPolicyValue value_;

};

TAO_END_VERSIONED_NAMESPACE_DECL

#if defined(_MSC_VER)
# pragma warning(pop)
#endif /* _MSC_VER */

#include /**/ "ace/post.h"
#endif /* TAO_POAFILTERING_POLICY_I_H */
